/*	
 *	main.c
 *
 *	PcePop - P/ECE PopUp (`)
 *	Copyright (C) 2003 Naoyuki Sawa
 *
 *	* Tue Feb 25 06:00:00 JST 2003 Naoyuki Sawa
 *	- 1st [XB
 *	* Mon Feb  3 12:30:00 JST 2003 Naoyuki Sawa
 *	- P/ECEڑ܂ܑ̋@̎t/OsꍇɂA
 *	  AvP[VNĂ܂ĂsC܂B
 */
#define STRICT
#include <windows.h>
#include <dbt.h>
#include <setupapi.h>
#pragma comment(lib, "setupapi.lib")

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "resource.h"

/****************************************************************************
 *	
 ****************************************************************************/

#include <initguid.h>
DEFINE_GUID(GUID_CLASS_PIECE_DRIVER, 
0xae284617, 0x35d6, 0x4c34, 0x8e, 0xd5, 0x55, 0xd9, 0xff, 0x53, 0x9c, 0x7b);

#define APP_TITLE	"P/ECE PopUp"
#define APP_NAME	"PcePop"
#define DEFAULT_PROGRAM	"C:\\usr\\PIECE\\bin\\WinIsd.exe"

BOOL CALLBACK DialogProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
void DoMenu();
void DoConfig();
int DeviceSearch();
void DoLaunch();
int ProgramStat();

/****************************************************************************
 *	
 ****************************************************************************/

#define WM_NOTIFY_ICON	(WM_APP + 1)

#define SEC_CONFIG	"CONFIG"
#define KEY_PROGRAM	"PROGRAM"

HINSTANCE g_hInstance;		/* CX^Xnh */
HWND g_hWnd;			/* ݒ_CAO */
NOTIFYICONDATA g_nid;		/* ^XNgCւ̃ACRo^/p\ */
HICON g_hIcon[2];		/* 0:P/ECEȂA1:P/ECE */

char ini_path[_MAX_PATH];	/* INIt@C̃pX */
char g_program[MAX_PATH];	/* NvÕt@C */
HANDLE g_hProcess;		/* NvÕvZXnh */

int device_exists;		/* 1:P/ECEڑĂ/0:Ȃ */

/****************************************************************************
 *	WinMain
 ****************************************************************************/

int PASCAL
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	int retval;
	HANDLE hMutex;
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	MSG msg;

	/* dNh~B */
	hMutex = CreateMutex(NULL, FALSE, APP_TITLE);
	if(!hMutex) {
		MessageBox(NULL, "CreateMutex()sI", APP_TITLE, MB_ICONSTOP | MB_OK);
		exit(1);
	}
	retval = WaitForSingleObject(hMutex, 0);
	if(retval != WAIT_OBJECT_0) {
		CloseHandle(hMutex);
		exit(0);
	}

	/* CX^Xnhi[܂B */
	g_hInstance = hInstance;

	/* INIt@C쐬܂B */
	retval = GetModuleFileName(NULL, ini_path, sizeof ini_path);
	if(!retval) {
		MessageBox(NULL, "GetModuleFileName()sI", APP_TITLE, MB_ICONSTOP | MB_OK);
		exit(1);
	}
	_splitpath(ini_path, drive, dir, fname, ext);
	_makepath(ini_path, drive, dir, fname, ".ini");

	/* NvOǂݍ݂܂B */
	GetPrivateProfileString(SEC_CONFIG, KEY_PROGRAM, "", g_program, sizeof g_program, ini_path);
	if(strlen(g_program) == 0) { /* ǂݍ߂Ȃ... */
		/* ݒȂAftHgvOݒB */
		strcpy(g_program, DEFAULT_PROGRAM);
	}

	/* ݒ_CAO쐬܂B */
	g_hWnd = CreateDialog(g_hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, DialogProc);
	if(!g_hWnd) {
		MessageBox(NULL, "CreateDialog()sI", APP_TITLE, MB_ICONSTOP | MB_OK);
		exit(1);
	}
	/* ܂\܂B */

	/* ACR[h܂B */
	g_hIcon[0] = LoadIcon(g_hInstance, MAKEINTRESOURCE(IDI_ICON1));
	g_hIcon[1] = LoadIcon(g_hInstance, MAKEINTRESOURCE(IDI_ICON2));
	if(!g_hIcon[0] || !g_hIcon[1]) {
		MessageBox(NULL, "LoadIcon()sI", APP_TITLE, MB_ICONSTOP | MB_OK);
		exit(1);
	}

	/* ԂP/ECEڑĂ邩ǂ𒲂ׂ܂B */
	device_exists = DeviceSearch();

	/* ^XNgCւ̓o^/̂߂̍\̂pӂ܂B */
	memset(&g_nid, 0, sizeof g_nid);
	g_nid.cbSize = sizeof g_nid;
	g_nid.hWnd = g_hWnd;
	g_nid.uID = 1;
	g_nid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	g_nid.uCallbackMessage = WM_NOTIFY_ICON;
	g_nid.hIcon = g_hIcon[device_exists]; /* ACRI */
	strcpy(g_nid.szTip, APP_TITLE);

	/* ^XNgCɓo^܂B */
	retval = Shell_NotifyIcon(NIM_ADD, &g_nid);
	if(!retval) {
		MessageBox(NULL, "Shell_NotifyIcon()sI", APP_TITLE, MB_ICONSTOP | MB_OK);
		exit(1);
	}

	/* bZ[W[vB */
	while(GetMessage(&msg, NULL, 0, 0)) {
		if(IsDialogMessage(g_hWnd, &msg)) continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	/* ^XNgCmɓo^܂B */
	Shell_NotifyIcon(NIM_DELETE, &g_nid);

	/* ݒ_CAO폜܂B */
	DestroyWindow(g_hWnd);

	/* vZXnhmɊJ܂B */
	if(g_hProcess) {
		CloseHandle(g_hProcess);
		g_hProcess = NULL;
	}

	/* dNh~܂B */
	ReleaseMutex(hMutex);
	CloseHandle(hMutex);

	return msg.wParam;
}

/****************************************************************************
 *	DialogProc
 ****************************************************************************/

BOOL CALLBACK
DialogProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int retval;
	OPENFILENAME ofn;
	char tmpstr[_MAX_PATH];

	switch(msg) {
	/*-------------------- ݒ_CAOUIbZ[W --------------------*/
	case WM_SHOWWINDOW:
		if(wParam) { /* \ */
			/* vOZbgB */
			SetDlgItemText(g_hWnd, IDC_PROGRAM, g_program);
		}
		return TRUE;
	case WM_COMMAND:
		switch(wParam) {
		case IDC_BROWSE:
			/* t@CIB */
			strcpy(tmpstr, g_program);
			memset(&ofn, 0, sizeof ofn);
			ofn.lStructSize = sizeof ofn;
			ofn.hwndOwner = g_hWnd;
			ofn.lpstrFilter = "s\t@C(*.exe)\0*.exe\0";
			ofn.lpstrFile = tmpstr;
			ofn.nMaxFile = sizeof tmpstr;
			ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
			ofn.lpstrDefExt = "exe";
			ofn.lpstrTitle = "vOI";
			retval = GetOpenFileName(&ofn);
			if(retval) {
				SetDlgItemText(g_hWnd, IDC_PROGRAM, tmpstr);
			}
			return TRUE;
		case IDOK:
			/* ÂvOۑB */
			strcpy(tmpstr, g_program);
			/* VvO擾B */
			GetDlgItemText(g_hWnd, IDC_PROGRAM, g_program, sizeof g_program);
			/* OIt邩킩Ȃ̂ŁAɐݒ薼ۑ܂B */
			WritePrivateProfileString(SEC_CONFIG, KEY_PROGRAM, g_program, ini_path);
			/* vOωAÂvÕvZX҂B */
			if(_strcmpi(g_program, tmpstr) != 0) {
				if(g_hProcess) {
					CloseHandle(g_hProcess);
					g_hProcess = NULL;
				}
			}
			/* FALL THRU */
		case IDCANCEL:
			/* 폜܂BBB */
			ShowWindow(g_hWnd, SW_HIDE);
			return TRUE;
		}
		return TRUE;
	/*-------------------- ^XNgCACR̃bZ[W --------------------*/
	case WM_NOTIFY_ICON:
		/* Ƀ_CAO\ȂAOʂֈړB */
		if(IsWindowVisible(g_hWnd)) {
			SetForegroundWindow(g_hWnd);
			return TRUE;
		}
		switch(lParam) {
		case WM_RBUTTONUP:
			DoMenu();	/* E{^Ńj[\ */
			return TRUE;
		case WM_LBUTTONDBLCLK:
			DoLaunch();	/* _uNbNł܂s */
			return TRUE;
		}
		return TRUE;
	/*-------------------- foCX`FW̃bZ[W --------------------*/
	case WM_DEVICECHANGE:
		switch(wParam) {
		//{{USBfoCX̔ł́ADBT_DEVNODES_CHANGEDȊO͗܂B
		//  hCo̍ł́ADBT_DEVICEARRIVAL邻łA
		//  茳USBL[{[hP/ECEł́AǂDBT_DEVNODES_CHANGED܂łB
		//  Ƃ킯ŁADBT_DEVNODES_CHANGEDȊO͖邱Ƃɂ܂B
		///* ǉꂽfoCXp\ƂȂ܂B */
		//case DBT_DEVICEARRIVAL:
		//	OutputDebugString("DBT_DEVICEARRIVAL\n");
		//	return TRUE;
		///* foCX̍폜v܂BׂẴAvP[V́A폜vƂł܂B */
		//case DBT_DEVICEQUERYREMOVE:
		//	OutputDebugString("DBT_DEVICEQUERYREMOVE\n");
		//	return TRUE;
		///* foCX̍폜v܂B */
		//case DBT_DEVICEQUERYREMOVEFAILED:
		//	OutputDebugString("DBT_DEVICEQUERYREMOVEFAILED\n");
		//	return TRUE;
		///* foCX폜悤ƂĂ܂Bۂł܂B */
		//case DBT_DEVICEREMOVEPENDING:
		//	OutputDebugString("DBT_DEVICEREMOVEPENDING\n");
		//	return TRUE;
		///* foCX폜܂B */
		//case DBT_DEVICEREMOVECOMPLETE:
		//	OutputDebugString("DBT_DEVICEREMOVECOMPLETE\n");
		//	return TRUE;
		///* foCXɌŗLȃCxgłB */
		//case DBT_DEVICETYPESPECIFIC:
		//	OutputDebugString("DBT_DEVICETYPESPECIFIC\n");
		//	return TRUE;
		///* ݂̐ݒ肪ύX܂B */
		//case DBT_CONFIGCHANGED:
		//	OutputDebugString("DBT_CONFIGCHANGED\n");
		//	return TRUE;
		//}}USBfoCX̔ł́ADBT_DEVNODES_CHANGEDȊO͗܂B
		/* foCXm[hύX܂B */
		case DBT_DEVNODES_CHANGED:
			OutputDebugString("DBT_DEVNODES_CHANGED\n");
			/* DBT_DEVNODES_CHANGED́AǂȃfoCXǉ/폜ꂽƂ
			 * ĂȂilParam=0ŗ܂ĵŁA͂Œׂ邵Ȃ悤łB
			 */
			if(DeviceSearch()) {
				/* P/ECEȂɕω... */
				if(!device_exists) {
					device_exists = 1; /* P/ECE}[N */
					g_nid.hIcon = g_hIcon[device_exists]; /* P/ECEACRɐ؂芷 */
					retval = Shell_NotifyIcon(NIM_MODIFY, &g_nid);
					if(!retval) {
						MessageBox(NULL, "Shell_NotifyIcon()sI", APP_TITLE, MB_ICONSTOP | MB_OK);
						exit(1);
					}
					DoLaunch(); /* AvP[VNgC */
				}
			} else {
				/* P/ECE聨Ȃɕω... */
				if(device_exists) {
					device_exists = 0; /* P/ECEȂ}[N */
					g_nid.hIcon = g_hIcon[device_exists]; /* P/ECEȂACRɐ؂芷 */
					retval = Shell_NotifyIcon(NIM_MODIFY, &g_nid);
					if(!retval) {
						MessageBox(NULL, "Shell_NotifyIcon()sI", APP_TITLE, MB_ICONSTOP | MB_OK);
						exit(1);
					}
				}
			}
			return TRUE;
		}
		return TRUE;
	}
	return FALSE;
}

/****************************************************************************
 *	DoMenu
 ****************************************************************************/

void
DoMenu()
{
	int retval;
	HMENU hMenu;
	HMENU hSubMenu;
	MENUITEMINFO mi;
	POINT point;

	/* j[[h܂B */
	hMenu = LoadMenu(g_hInstance, MAKEINTRESOURCE(IDR_MAIN));
	if(hMenu == NULL) {
		MessageBox(NULL, "LoadMenu()sI", APP_TITLE, MB_ICONSTOP | MB_OK);
		exit(1);
	}
	hSubMenu = GetSubMenu(hMenu, 0);
	if(hSubMenu == NULL) {
		MessageBox(NULL, "GetSubMenu()sI", APP_TITLE, MB_ICONSTOP | MB_OK);
		exit(1);
	}

	/* vONԂɂāAj[ڂ̏Ԃς܂B */
	memset(&mi, 0, sizeof mi);
	mi.cbSize = sizeof mi;
	mi.fMask = MIIM_STATE;
	retval = GetMenuItemInfo(hSubMenu, ID_LAUNCH, FALSE, &mi);
	if(!retval) {
		MessageBox(NULL, "GetMenuItemInfo()sI", APP_TITLE, MB_ICONSTOP | MB_OK);
		exit(1);
	}
	if(ProgramStat()) { /* ɋN */
		mi.fState |= MFS_GRAYED;
	} else {
		mi.fState |= MFS_DEFAULT;
	}
	retval = SetMenuItemInfo(hSubMenu, ID_LAUNCH, FALSE, &mi);
	if(!retval) {
		MessageBox(NULL, "SetMenuItemInfo()sI", APP_TITLE, MB_ICONSTOP | MB_OK);
		exit(1);
	}

	/* j[\܂B */
	GetCursorPos(&point);
	SetForegroundWindow(g_hWnd); /* KvIȂƃj[ȊȌꏊNbNĂj[Ȃ */
	retval = TrackPopupMenu(hSubMenu,
		TPM_RIGHTALIGN | TPM_BOTTOMALIGN | TPM_RIGHTBUTTON | TPM_RETURNCMD,
		point.x, point.y,
		0,
		g_hWnd,
		NULL);

	/* j[J܂B */
	DestroyMenu(hMenu);

	/* Iꂽڂɂ... */
	switch(retval) {
	case ID_LAUNCH:
		DoLaunch();
		return;
	case ID_CONFIG:
		ShowWindow(g_hWnd, SW_SHOW);
		return;
	case ID_EXIT:
		PostQuitMessage(0);
		return;
	}
}

/****************************************************************************
 *	DoConfig
 ****************************************************************************/

void
DoConfig()
{
	ShowWindow(g_hWnd, SW_SHOW);
}

/****************************************************************************
 *	DeviceSearch
 ****************************************************************************/

int
DeviceSearch()
{
	int result = 0;
	HDEVINFO hDevInfo;
	SP_INTERFACE_DEVICE_DATA DevData;

	hDevInfo = SetupDiGetClassDevs((GUID*)&GUID_CLASS_PIECE_DRIVER, NULL, NULL, DIGCF_PRESENT | DIGCF_DEVICEINTERFACE); // P/ECEhĂȂĂ͐܂B
	if(hDevInfo != INVALID_HANDLE_VALUE) {
		memset(&DevData, 0, sizeof DevData);
		DevData.cbSize = sizeof DevData;
		result = SetupDiEnumDeviceInterfaces(hDevInfo, NULL, (GUID*)&GUID_CLASS_PIECE_DRIVER, 0, &DevData); // hĂ邩hĂȂ͂Ŕf܂B
		SetupDiDestroyDeviceInfoList(hDevInfo); // SetupDiGetClassDevs()ꍇ͂ĂŃ\[XĴYꂸɁI
	}

	return result;
}

/****************************************************************************
 *	ProgramStat
 ****************************************************************************/

int
ProgramStat()
{
	int retval;

	/* vONĂ... */
	if(g_hProcess) {
		/* IĂH */
		retval = WaitForSingleObject(g_hProcess, 0);
		if(retval != WAIT_OBJECT_0) return 1; /* NȂ */

		/* IĂnhJB */
		CloseHandle(g_hProcess);
		g_hProcess = NULL;
	}

	return 0;
}

/****************************************************************************
 *	DoLaunch
 ****************************************************************************/

/* dN`FbNŎsꍇ̂݁A0ȊOԂ܂B */
void
DoLaunch()
{
	int retval;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	char str[_MAX_PATH * 2];

	/* ݒ_CAO\ȂAvON܂B */
	if(IsWindowVisible(g_hWnd)) return;

	/* ɃvOsȂAvON܂B */
	if(ProgramStat()) return;

	/* u܂vOI܂Hv_CAOd\h~̂߁B */
	{
		static int busy;
		if(!busy) {
			busy = 1;	/* ȍ~AreturnŔȂ悤ɁI */

			/* vON܂B */
			memset(&si, 0, sizeof si);
			si.cb = sizeof si;
			memset(&pi, 0, sizeof pi);
			retval = CreateProcess(g_program, NULL, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL, &si, &pi);
			if(retval) {
				/* Xbhnh͑ɊJAvZXnĥ͎߂ɕۑB */
				CloseHandle(pi.hThread);
				g_hProcess = pi.hProcess;
			} else {
				sprintf(str, "u%sv̋NɎs܂B\n܂vOI܂H", g_program);
				retval = MessageBox(g_hWnd, str, APP_TITLE, MB_ICONEXCLAMATION | MB_YESNO);
				if(retval == IDYES) DoConfig();
			}

			busy = 0;
		}
	}
}
